<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getFactSamenvatInfoResponse StructType
 * Meta informations extracted from the WSDL
 * - documentation: error1: Kan geen relatie vinden, er is geen relNo opgegeven. | error2: Kan geen relatie vinden obv de opgegeven relNo. | error999: Deze functionaliteit is niet geimplementeerd.
 * @subpackage Structs
 */
class GetFactSamenvatInfoResponse extends AbstractStructBase
{
    /**
     * The requestTag
     * Meta informations extracted from the WSDL
     * - documentation: Vrij veld voor aanroepende partij. De inhoud van dit veld wordt altijd identiek teruggestuurd.
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * - maxLength: 4000
     * @var string
     */
    public $requestTag;
    /**
     * The factuurSamenvattingen
     * Meta informations extracted from the WSDL
     * - documentation: De lijst met factuur samenvattingen.
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FactSamenvatInfoV4
     */
    public $factuurSamenvattingen;
    /**
     * Constructor method for getFactSamenvatInfoResponse
     * @uses GetFactSamenvatInfoResponse::setRequestTag()
     * @uses GetFactSamenvatInfoResponse::setFactuurSamenvattingen()
     * @param string $requestTag
     * @param \StructType\FactSamenvatInfoV4 $factuurSamenvattingen
     */
    public function __construct($requestTag = null, \StructType\FactSamenvatInfoV4 $factuurSamenvattingen = null)
    {
        $this
            ->setRequestTag($requestTag)
            ->setFactuurSamenvattingen($factuurSamenvattingen);
    }
    /**
     * Get requestTag value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRequestTag()
    {
        return isset($this->requestTag) ? $this->requestTag : null;
    }
    /**
     * Set requestTag value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $requestTag
     * @return \StructType\GetFactSamenvatInfoResponse
     */
    public function setRequestTag($requestTag = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($requestTag) && strlen($requestTag) > 4000) || (is_array($requestTag) && count($requestTag) > 4000)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 4000 element(s) or a scalar of 4000 character(s) at most, "%d" length given', is_scalar($requestTag) ? strlen($requestTag) : count($requestTag)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($requestTag) && !is_string($requestTag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($requestTag)), __LINE__);
        }
        if (is_null($requestTag) || (is_array($requestTag) && empty($requestTag))) {
            unset($this->requestTag);
        } else {
            $this->requestTag = $requestTag;
        }
        return $this;
    }
    /**
     * Get factuurSamenvattingen value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FactSamenvatInfoV4|null
     */
    public function getFactuurSamenvattingen()
    {
        return isset($this->factuurSamenvattingen) ? $this->factuurSamenvattingen : null;
    }
    /**
     * Set factuurSamenvattingen value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\FactSamenvatInfoV4 $factuurSamenvattingen
     * @return \StructType\GetFactSamenvatInfoResponse
     */
    public function setFactuurSamenvattingen(\StructType\FactSamenvatInfoV4 $factuurSamenvattingen = null)
    {
        if (is_null($factuurSamenvattingen) || (is_array($factuurSamenvattingen) && empty($factuurSamenvattingen))) {
            unset($this->factuurSamenvattingen);
        } else {
            $this->factuurSamenvattingen = $factuurSamenvattingen;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetFactSamenvatInfoResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
