<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PropositiePremiumsTabV4 StructType
 * Meta informations extracted from the WSDL
 * - documentation: Een lijst met de gevonden premiums bij de propositie
 * @subpackage Structs
 */
class PropositiePremiumsTabV4 extends AbstractStructBase
{
    /**
     * The propositiePremium
     * Meta informations extracted from the WSDL
     * - documentation: Een lijst met de gevonden premiums bij de propositie.
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: false
     * @var \StructType\PropositiePremiumsV4[]
     */
    public $propositiePremium;
    /**
     * Constructor method for PropositiePremiumsTabV4
     * @uses PropositiePremiumsTabV4::setPropositiePremium()
     * @param \StructType\PropositiePremiumsV4[] $propositiePremium
     */
    public function __construct(array $propositiePremium = array())
    {
        $this
            ->setPropositiePremium($propositiePremium);
    }
    /**
     * Get propositiePremium value
     * @return \StructType\PropositiePremiumsV4[]|null
     */
    public function getPropositiePremium()
    {
        return $this->propositiePremium;
    }
    /**
     * Set propositiePremium value
     * @throws \InvalidArgumentException
     * @param \StructType\PropositiePremiumsV4[] $propositiePremium
     * @return \StructType\PropositiePremiumsTabV4
     */
    public function setPropositiePremium(array $propositiePremium = array())
    {
        foreach ($propositiePremium as $propositiePremiumsTabV4PropositiePremiumItem) {
            // validation for constraint: itemType
            if (!$propositiePremiumsTabV4PropositiePremiumItem instanceof \StructType\PropositiePremiumsV4) {
                throw new \InvalidArgumentException(sprintf('The propositiePremium property can only contain items of \StructType\PropositiePremiumsV4, "%s" given', is_object($propositiePremiumsTabV4PropositiePremiumItem) ? get_class($propositiePremiumsTabV4PropositiePremiumItem) : gettype($propositiePremiumsTabV4PropositiePremiumItem)), __LINE__);
            }
        }
        $this->propositiePremium = $propositiePremium;
        return $this;
    }
    /**
     * Add item to propositiePremium value
     * @throws \InvalidArgumentException
     * @param \StructType\PropositiePremiumsV4 $item
     * @return \StructType\PropositiePremiumsTabV4
     */
    public function addToPropositiePremium(\StructType\PropositiePremiumsV4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PropositiePremiumsV4) {
            throw new \InvalidArgumentException(sprintf('The propositiePremium property can only contain items of \StructType\PropositiePremiumsV4, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->propositiePremium[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PropositiePremiumsTabV4
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
